# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/tomcat/servlet-api/%{version}-brew 
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src


%define base_name servletapi
%define full_name jakarta-%{base_name}
%define section   free

Name:           servletapi4
Version:        4.0.4
Release:	6.2.1.3%{?dist}
Epoch:          0
Summary:        Java Servlet 2.3 and JSP 1.2 API classes
License:        Apache License
Group:          Internet/WWW/Dynamic Content
Source0:        %{full_name}-4-src.tar.gz
Source1:        servletapi4-4.0.4.pom
Source2:	servletapi4-component-info.xml
Url:            http://tomcat.apache.org/
Requires:         java >= 0:1.5.0
Requires(preun):  /usr/sbin/update-alternatives
Requires(post):   /usr/sbin/update-alternatives
Requires(post):   jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3


BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires: maven-deploy-plugin

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot
Provides:       servlet
Provides:       servlet_api
Provides:       servlet_2_3_api
Provides:       jsp_api
Provides:       jsp_1_2_api
# We need to provide for backwards compatibility
Provides:	servlet23

%description
This subproject contains the source code for the implementation classes
of the Java Servlet and JSP APIs (packages javax.servlet).

%package javadoc
Group:            Development/Documentation
Summary:          Javadoc for %{name}
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm


%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{full_name}-4-src
find . -name "*.jar" -exec rm -f {} \;

%build
export JAVA_HOME=%{_jvmdir}/java-1.6.0
ant dist -Dservletapi.build=build -Dservletapi.dist=dist

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
install -m 644 dist/lib/servlet.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap javax.servlet servlet-api 2.3 JPP servlet_2_3_api
%add_to_maven_depmap tomcat servlet-api %{version} JPP %{name}
%add_to_maven_depmap javax.servlet jsp-api 1.2 JPP jsp_1_2_api
%add_to_maven_depmap tomcat jsp-api %{version} JPP %{name}
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}
cp -pr build/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}

%{_bindir}/mvn-jpp deploy:deploy-file -Dfile=%{buildroot}%{_javadir}/servletapi4.jar -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom -Durl=file://%{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases

%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE2} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/servletapi4.pom
%{__cp} -p %{buildroot}%{_javadir}/servletapi4.jar %{buildroot}%{repodirlib}/servletapi4.jar
%endif


%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%postun
%update_maven_depmap

%post
%update_maven_depmap
update-alternatives --install %{_javadir}/servlet.jar servlet %{_javadir}/%{name}-%{version}.jar 20300
update-alternatives --install %{_javadir}/servlet_2_3_api.jar servlet_2_3_api %{_javadir}/%{name}-%{version}.jar 20300
update-alternatives --install %{_javadir}/servlet_api.jar servlet_api %{_javadir}/%{name}-%{version}.jar 20300
update-alternatives --install %{_javadir}/jsp_1_2_api.jar jsp_1_2_api %{_javadir}/%{name}-%{version}.jar 10200
update-alternatives --install %{_javadir}/jsp_api.jar jsp_api %{_javadir}/%{name}-%{version}.jar 10200

%preun
if [ "$1" = "0" ]; then
    update-alternatives --remove servlet %{_javadir}/%{name}-%{version}.jar
    update-alternatives --remove servlet_api %{_javadir}/%{name}-%{version}.jar
    update-alternatives --remove servlet_2_3_api %{_javadir}/%{name}-%{version}.jar
    update-alternatives --remove jsp_api %{_javadir}/%{name}-%{version}.jar
    update-alternatives --remove jsp_1_2_api %{_javadir}/%{name}-%{version}.jar
fi

%files
%defattr(-,root,root)
%doc LICENSE README.txt
%{_javadir}*/*
%{_datadir}/maven2
%{_mavendepmapfragdir}

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Jan 25 2011 Yiqiao Wang <yiwang@redhat.com> - 0:4.0.4-6.2.1.3
- Add repolib 

* Wed Nov 24 2010 Yiqiao Wang <yiwang@redhat.com> - 0:4.0.4-6.2.1.2
- Build on RHEl6
- Fix %%files for signed jars
- Add the line to find and remove any binaries

* Thu Jun 10 2010 Yiqiao Wang <yiwang@redhat.com> - 0:4.0.4-6.2.1.1
- rebuild

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:4.0.4-6.2.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com>  4.0.4-6.2
- Rebuild
- Change BR: java-devel = 0:1.5.0 to java-devel >= 0:1.5.0
- Change JAVA_HOME from 1.5 to 1.6

* Fri Jan 30 2009 Fernando Nasser <fnasser@redhat.com> 4.0.4-6.1
- Provide servlet23 for backwards compatibility

* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 4.0.4-6
- Auto rebuild for JPackage 5 in mock

* Thu Mar 06 2008 Ralph Apel <r.apel@r-apel.de> 0:4.0.4-5jpp
- Add poms and depmap frags
- Provide standard virtual provides and alternatives

* Mon Apr 24 2006 Fernando Nasser <fnasser@redhat.com> 4.0.4-4jpp
- First JPP 1.7 build

* Wed Nov 16 2005 Fernando Nasser <fnasser@redhat.com> 4.0.4-3jpp_5rh
- New 6-digit alternative priority

* Tue Oct 25 2005 Fernando Nasser <fnasser@redhat.com> 4.0.4-3jpp_4rh
- Alternatives priority must be based on API version

* Mon Nov 22 2004 Fernando Nasser <fnasser@redhat.com> 4.0.4-3jpp_2rh
- Rebuild

* Thu Mar  4 2004 Frank Ch. Eigler <fche@redhat.com> 4.0.4-3jpp_1rh
- RH vacuuming

* Tue Mar 25 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 4.0.4-3jpp
- for jpackage-utils 1.5

* Fri Oct 25 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 4.0.4-2jpp
- only one alternative (servlet)
- do not remove alternatives on upgrades
- group, vendor, distribution tags

* Wed Jun 26 2002 Henri Gomez <hgomez@slib.fr> 4.0.4-1jpp
- remove version in javadoc dir for Tomcat 4.0.4 build purposes

* Wed Jun 12 2002 Henri Gomez <hgomez@slib.fr> 4.0.3-2jpp
- use sed instead of bash 2.x extension in link area to make spec compatible
  with distro using bash 1.1x

* Mon Jun 10 2002 Henri Gomez <hgomez@slib.fr> 4.0.3-1jpp
- added servlet23 alternative (servlet-2.3)

* Mon Mar 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 4.0.1-3jpp 
- renamed once again (hope last time) to servletapi3
- provide servlet resource with priority 40

* Mon Jan 21 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 4.0.1-2jpp 
- fixed javadoc package group
- section macro

* Fri Jan 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 4.0.1-1jpp
- renamed from servlet23 to servlet4
- 4.0.1
- provides servlet_spec-2.3 resource with 50 priority
- requires /usr/sbin/update-alternatives
- versioned dir for javadoc
- no dependencies for javadoc package
- spec cleanup

* Fri Nov 23 2001 Henri Gomez <hgomez@slib.fr> 3.2.4-1jpp
- 3.2.4
- renamed from servletapi3 to servlet22
- built using jikes 1.15
- removed packager tag
- javadoc live now in /usr/share/javadoc/servlet3
- manual renamed  to javadoc

* Sat Oct 20 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 3.2.3-3mdk
- s/jPackage/JPackage
- used original tarball

* Fri Sep 14 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 3.2.3-2mdk
- changed jar name to %{name}.jar

* Sun Aug 26 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 3.2.3-1mdk
- 3.2.3 
- vendor tag
- packager tag
- s/Copyright/License/
- truncated description to 72 columns in spec
- spec cleanup
- used versioned jar
- used new source packaging policy

* Sat Feb 10 2001 Guillaume Rousse <g.rousse@mandrake-linux.com> 3.2-1mdk
- first Mandrake release
